% Create a Gateway File to run C - files in MatLab
% Version 1.5
% Lang Klaus
% 11.2009 bis 01.2010
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Einleitung
function Create_Gateway
clc

fprintf('\nCREATE GATEWAY Vers. 1.5\n\n');
fprintf('__________________________________________________________________________________________\n');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a = dir;                                                                    % Dateiliste
% Auswahl des Master C - files
indices = [];
for k = 1 : numel(a)
    index = findstr(a(k).name,'.');
    suffix = a(k).name(index+1:end);
    if(strcmp(suffix,'c') | strcmp(suffix,'cpp'))
        indices = [indices,k]; 
    end
end
if(isempty(indices))
    error('Keine *.c oder *.cpp Dateien gefunden!');
end
c_files = a(indices);
fprintf('\nIm Current Directory stehen folgende Dateien als C - Masterfile zur Auswahl:\n');
for k = 1 : numel(c_files)
    fprintf('\n[%d] \t\t %s',k,c_files(k).name);
end
fprintf('\n\n[0]\t\t Abbruch des Programms');
fprintf('\n\n-->  ');
wahl = input('','s');
if strcmp(wahl,'0')
    error('Programmabbruch durch den Benutzer!');
end
fehler = 1;
for k = 0 : numel(c_files)
    if strcmp(num2str(k),wahl)
        fehler = 0;
    end
end
if fehler == 1
    error('Eingabe muss eine natrliche Zahl zwischen 0 und %d sein!',numel(c_files));
end
wahl = str2num(wahl);
dateiname = c_files(wahl).name;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aufruf von "get_data"
% In diesem Programm werden alle ntigen Daten aus dem c - files ausgelsesn um das Gateway -
% File zu erstellen
[anz_param,funktionsname,daten,all_input] = get_data(dateiname);



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Aufruf von "write_file"
write_file(anz_param,funktionsname,daten,all_input,dateiname);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('__________________________________________________________________________________________\n');
fprintf('\nProgrammaufruf:\n');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% String zusammenbauen

str1 = [];                                                                  % String vor dem =
str2 = [];                                                                  % string nach dem =
str3 = [];                                                                  % String nach Input Parameter

for k = 1 : anz_param(1)
    switch cell2mat(daten(k,2))
        case 'Out'
            switch cell2mat(daten(k,3))
                case 'Skalar'
                    str1 = [str1,cell2mat(daten(k,5)),','];                    
                case 'Vektor'
                    str1 = [str1,cell2mat(daten(k,5)),','];
                    str3 = [str3,'numel(',cell2mat(daten(k,5)),'),'];
                case 'Matrix'
                    str1 = [str1,cell2mat(daten(k,5)),','];
                    str3 = [str3,'size(',cell2mat(daten(k,5)),'),'];
                case 'String'
                    str1 = [str1,cell2mat(daten(k,5)),','];
                otherwise
                    error('Fehler!')
            end          
        case 'In'
            switch cell2mat(daten(k,3))
                case 'Skalar'
                    str2 = [str2,cell2mat(daten(k,5)),','];
                case 'Vektor'
                    if strcmp(cell2mat(daten(k,4)),'int')
                        str2 = [str2,'int32(',cell2mat(daten(k,5)),'),'];
                    else
                        str2 = [str2,cell2mat(daten(k,5)),','];
                    end  
                case 'Matrix'
                    if strcmp(cell2mat(daten(k,4)),'int')
                        str2 = [str2,'int32(',cell2mat(daten(k,5)),'),'];
                    else
                        str2 = [str2,cell2mat(daten(k,5)),','];
                    end 
                case 'String'
                    str2 = [str2,cell2mat(daten(k,5)),','];    
                otherwise
                    error('Fehler!')
            end
        case 'IO'
            switch cell2mat(daten(k,3))                    
                case 'Vektor'
                    str1 = [str1,cell2mat(daten(k,5)),','];
                    if strcmp(cell2mat(daten(k,4)),'int')
                        str2 = [str2,'int32(',cell2mat(daten(k,5)),'),'];
                    else
                        str2 = [str2,cell2mat(daten(k,5)),','];
                    end    
                case 'Matrix'
                    str1 = [str1,cell2mat(daten(k,5)),','];
                    if strcmp(cell2mat(daten(k,4)),'int')
                        str2 = [str2,'int32(',cell2mat(daten(k,5)),'),'];
                    else
                        str2 = [str2,cell2mat(daten(k,5)),','];
                    end     
                case 'String'
                    str1 = [str1,cell2mat(daten(k,5)),','];
                    str2 = [str2,cell2mat(daten(k,5)),','];
                otherwise
                    error('Fehler!')
            end
    end
end

% Lschen
if ~isempty(str1)
    str1(str1 == '[') = [];
    str1(str1 == ']') = [];
    str1(str1 == '*') = [];
    str1(end) = [];
end
if ~isempty(str2)
    str2(str2 == '[') = [];
    str2(str2 == ']') = [];
    str2(str2 == '*') = [];
    str2(end) = [];
end

if ~isempty(str3)
    str3(str3 == '[') = [];
    str3(str3 == ']') = [];
    str3(str3 == '*') = [];
    str3(end) = [];
end

if isempty(str3)
    fprintf('\n[%s] = c2m_%s(%s);\n\n',str1,funktionsname,str2);
else
    fprintf('\n[%s] = c2m_%s(%s,%s);\n\n',str1,funktionsname,str2,str3);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Abfrage ob gleich Kompiliert werden soll
fprintf('__________________________________________________________________________________________\n');
fprintf('\nc2m_%s.c\t jetzt compilieren? \t\t y/n [y] ',funktionsname);
reply = input('','s');
if ( isempty(reply) || strcmp(reply(1),'y') )
    fprintf('\n\nStarten des Compilierungsvorganges ...\n\n');
    
    c2m_file = ['c2m_',funktionsname,'.c'];
    
    mex(c2m_file)
    
    fprintf('\n... Abgeschlossen');
end
fprintf('\n\nEnd of Program\n');
% End of Programm